// ------------------------------------------------------------
// ARMv8-A AArch64 Generic Timer Access Functions
//
// Copyright Arm Ltd 2017. All rights reserved.
// ------------------------------------------------------------

 
  .section  AArch64_GenericTimer,"ax"
  .align 3


// ------------------------------------------------------------

  .global setTimerPeriod
  // void setTimerPeriod(uint32_t value)
  // Sets the value of the Secure EL1 Physical Timer Value Register (CNTPS_TVAL_EL1)
  // w0 - value - The value to be written into CNTPS_TVAL_EL1
  .type setTimerPeriod, "function"
setTimerPeriod:
  MSR     CNTP_TVAL_EL0, x0
  ISB
  RET
   
// ------------------------------------------------------------

  .global enableTimer
  .type enableTimer, "function"
enableTimer:
  MOV    x0, #0x1            // Set Enable bit, and clear Mask bit
  MSR    CNTP_CTL_EL0, x0
  ISB
  RET

// ------------------------------------------------------------

  .global disableTimer
  .type disableTimer, "function"
disableTimer:
  MSR    CNTP_CTL_EL0, xzr // Clear the enable bit
  ISB
  RET

// ------------------------------------------------------------
// End of code
// ------------------------------------------------------------