#include <stdio.h>
#include <stdint.h>
#include "pl011_uart.h"

//extern void gicInit(void);
extern uint32_t readIAR1(void);
extern void writeEOIR1(uint32_t);

extern void setTimerPeriod(uint32_t);
extern void enableTimer(void);
extern void disableTimer(void);

volatile uint32_t flag;
uint64_t timer_val;


int main (void) {
	uartInit((void*)(0x1C090000));

	//gicInit();
	
	printf("hello world\n");

	flag = 0;
	setTimerPeriod(0x1000);  // Generate an interrupt in 1000 ticks
	enableTimer();

	// Wait for the interrupt to arrive
	while(flag==0){
		// Inline assembly to print timer value, used for debugging, not necessary
		//__asm volatile ("MRS %[a], CNTPCT_EL0" : [a]"=r"(timer_val));
		//printf("Timer value: %lu\n", timer_val);
	}
	
	printf("Got interrupt!\n");

	return 0;
}

void fiqHandler(void) {
    uint32_t intid;
	intid = readIAR1();
	
	//interrupt id for non secure timer is different to the secure timer!
	if (intid == 30) {
		flag = 1;
		disableTimer();
    } else {
		printf("Should never reach here!\n");
	}
	writeEOIR1(intid);
	return;
}