

	.section NONSECURE
	.align 3

// ------------------------------------------------------------
.equ AArch64_EL2_SP2, 0x09 // EL2h
.equ AArch64_EL2_SP0, 0x08 // EL2t
.equ AArch64_EL1_SP1, 0x05 // EL1h
.equ AArch64_EL1_SP0, 0x04 // EL1t
.equ AArch64_EL0_SP0, 0x00


// ------------------------------------------------------------
// EL2 AArch64
// ------------------------------------------------------------
    .global el2_entry_aarch64
	.type el2_entry_aarch64, "function"
el2_entry_aarch64:	
  //ADRP x0, Image$$STACK_EL2$$ZI$$Limit
  //MOV  sp, x0
  // Configure HCR_EL2 - the hypervisor configuration register
  // ---------------------------------------------------------
  MRS      x0, HCR_EL2
  MOV	   x1, #0x0
  ORR	   x0, x0, x1
  MSR      HCR_EL2, x0

  // we can use the same vector table in this example, but in general
  // each combination of exception level, security state, and execution state
  // will need a new vector table
  // ADD YOUR CODE HERE
  LDR      x0, =vectors
  MSR	   VBAR_EL2, x0

  // Initialize SCTLR_EL1
  // --------------------
  // SCTLR_EL1 has an unknown reset value and must be configured
  // before we can enter EL1
  MSR 	   SCTLR_EL1, xzr

  // Enter EL1
  // ---------
  LDR 	   x0, =el1_entry_aarch64
  LDR      x1, =AArch64_EL1_SP1
  MSR 	   ELR_EL2, x0 //
  MSR 	   SPSR_EL2, x1
  ERET


// ------------------------------------------------------------
// EL1 AArch64
// ------------------------------------------------------------
    .global el1_entry_aarch64
	.type el1_entry_aarch64, "function"
el1_entry_aarch64:
  // we can use the same vector table in this example, but in general
  // each combination of exception level, security state, and execution state
  // will need a new vector table
  LDR      x0, =vectors
  MSR	   VBAR_EL1, x0
	
  //we must ensure that floating point register accesses are not trapped
  //since the c library for AArch64-v8A uses them
  MOV      x0, #(0x3 << 20)
  MSR      CPACR_EL1, x0
  
  // ensures that all instructions complete before 
  ISB
  // Branch to scatter loading and C library init code
  .global  __main
  B        __main
// ------------------------------------------------------------
// End of file
// ------------------------------------------------------------